﻿define bl = Character('凤梨', color="#fffec8")
define w = Character('我', color="#c8c8ff")
define zz = Character('竹笋', color="#c8ffc8")
define hr = Character('HR', color="#c8ffc8")
define rm2 = Character('舍友2', color="#ffc8c8")
define rm3 = Character('舍友3', color="#ffc8c8")
define rm4 = Character('舍友4', color="#ffc8c8")
define rm5 = Character('舍友5', color="#ffc8c8")
define rm6 = Character('舍友6', color="#ffc8c8")

define audio.bgm_morning_light = "bgm/01.Morning Light.ogg"
define audio.bgm_constant_daily = "bgm/02.変わらない日常.ogg"
define audio.bgm_happy_days = "bgm/03.Happy Days.ogg"
define audio.bgm_common_scenery = "bgm/04.Common Scenery.ogg"
define audio.bgm_tender_wrap = "bgm/07.優しさにつつまれて.ogg"
define audio.bgm_bravado_adult_secret_labo_quietver = "bgm/13.強がるオトナのSecretLabo (QuietVer.).ogg"
define audio.bgm_emotion = "bgm/23.Emotion.ogg"
define audio.bgm_take_into_account = "bgm/24.Take into Account.ogg"
define audio.bgm_usability_of_ability = "bgm/25.Usability of Ability.ogg"
define audio.bgm_astral_ability_guitarver = "bgm/38.astral ability (GuitarVer.).ogg"
define audio.bgm_astral_ability_pianover = "bgm/42.astral ability (PianoVer.).ogg"
define audio.se_walking = "soundeffect/walking.ogg"
define audio.se_keyboard_typing = "soundeffect/keyboard_typing.ogg"
define audio.se_writing = "soundeffect/writing.ogg"
define audio.se_phone_ring = "soundeffect/phone_ring.ogg"
define audio.se_knock_door = "soundeffect/knock_door.ogg"

default is_open_source_project = False
default open_source_switch_counter = 0
default bl_score = 0

default is_wrong_switch_project_introduce = False
default is_wrong_switch_linux_build = False
default is_wrong_switch_make_output = False
default is_wrong_switch_online_search = False
default is_wrong_switch_offline_search = False

init python:
    def is_entering_branch_good() -> bool:
        return bl_score >= 4
    def is_entering_branch_normal() -> bool:
        return bl_score > 0 and bl_score < 4
    def is_entering_branch_bad() -> bool:
        return bl_score < 0

label start:
    call common_chapter_1 from ret_common_chapter_1
    call common_chapter_2 from ret_common_chapter_2
    call common_chapter_3 from ret_common_chapter_3

    if is_entering_branch_bad():
        call branch_bad_chapter_3 from ret_branch_bad_chapter_3
    elif is_entering_branch_normal():
        call branch_normal_chapter_3 from ret_branch_normal_chapter_3
    else:
        call branch_good_chapter_3 from ret_branch_good_chapter_3
