label common_chapter_3:

label common_chapter_3_1:

    play music bgm_tender_wrap fadein 0.5 fadeout 0.5

    scene bg office_building dusk
    with fade

    """
    面试结束了。我怀揣着忐忑的心情离开了ShallowOut的写字楼。

    在离开面试场地时，面试官的情绪压的很低，我从他脸色上看不出任何欣喜或不悦的感情。
    """

    scene bg pedestrian_street dusk
    with fade

    """
    我走在前往地铁站的路上，准备回到我的临时住处。

    夕阳西下，天空被染成桔黄色。

    不知这桔黄色的天空究竟是在为我的面试感到遗憾而黄，还是感到喜悦而红。
    """

    scene bg apartment night
    with fade

    pause 1.0

    scene bg apartment_room night closed_window
    with fade

    play music bgm_bravado_adult_secret_labo_quietver fadein 0.5 fadeout 0.5

    """
    回到住处，洗漱一番，关闭屋中灯光后，我钻进了被窝。

    屋中只有空调的嗡嗡声作响。窗外时不时会传来汽车喇叭声，但大多都很遥远，声音细微且悠扬。

    屋中只有我的手机屏幕在悠悠的发出白光。

    手机屏幕上是空空的收件箱。

    我睡不着。
    """

    w "看看夜景吧。。。"

    scene bg apartment_room night open_window
    with fade

    """
    我翻身下床，走到窗台面前，拉开了窗帘。

    城市的灯红酒绿照进了我漆黑一片的屋内。

    我倚靠在窗台前静静地看着窗外灯光的流动。

    就这样一直看着，仿佛时间也停止了流动。
    """

    if is_entering_branch_bad():
        """
        夜已深，仍然没有消息发送过来。

        手机上的宿舍群在毕业后也基本没有消息了。
        
        大家似乎都成为了各自四年里的一个过客。

        抱着这样的想法，我的意识也逐渐模糊起来。
        """

        scene bg apartment_room night closed_window
        with fade

        """
        我拉上窗帘，屋内重回黑暗。
        
        回到了床上，带着深深的疲倦，渐渐在等待中睡着了。
        """

        play music bgm_astral_ability_guitarver fadein 0.5 fadeout 0.5

        scene bg apartment_room dawn
        with fade

        """
        清晨，一声声车水马龙的声音唤醒了我。

        打开手机，邮件列表里只静静地躺着一份邮件。

        信件是整点发出的，看起来就好像是计划好的一样。

        我没有细看信件的内容，但大抵又是我又被加入了所谓人才库一说。
        """

        w "这样啊。。。"

        """
        清晨的薄雾仍然笼罩在城市上空。

        相比较我的心境和未来而言，城市的这层雾显得是那么单薄。

        一切都结束了。
        """

    else:
        play sound se_phone_ring

        """
        叮咚。突如其来的提示音将我的思绪拉回了现实。
        
        伴随着一声提示音，一封邮件出现在我的收件箱。

        我怀着激动的心，颤抖着手点开邮件。

        “恭喜。。。经面试考核，您已被我司录用，请于。。。” -- ShallowOut公司人事部
        """

        w "。。。"

        """
        我说不出任何话，但此时无言胜过一切。

        我过去几个月所作的努力，都没有白费。
        """

        if is_entering_branch_good():
            play sound se_phone_ring

            """
            叮咚。一声意外的提示音响起。邮箱里又多了一封邮件。

            发件人我不认识。

            奇怪，还会有谁给我发邮件呢？

            我点开了邮件。

            “您好，我是今天面试您的[bl.name]。”

            信件开头的第一句话将我的思绪带回了面试场地内的那位面试官身上。

            “我对您的面试过程相当满意，想必您也应该收到了录用通知。”

            “我看到您对自由软件情有独钟，我个人也是。”

            “如果未来有机会，我们之间可以互相多交流。”

            信件读罢，我不知该说什么。一些复杂的情绪在我心中产生。

            一直以来我都是一个人写代码，将它们发布在GitHub上。
            
            我从未想过从它们中收获什么，我也从未将这份情感与任何人分享，因为它们对这些完全不了解。

            但现在看来，无论是我过去几个月所作的努力，又或者是过去更长时间内所作的一切，如今都创造了一个更美好的结果。
            """
        
    return
